/*
 * Créé le 10 mai 07
 *
 * Pour changer le modèle de ce fichier généré, allez à :
 * Fenêtre&gt;Préférences&gt;Java&gt;Génération de code&gt;Code et commentaires
 */
package fr.gouv.finances.cp.xemelios.common.config;

import java.util.HashMap;
import java.util.Vector;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

import fr.gouv.finances.cp.utils.xml.marshal.InvalidXmlDefinition;
import fr.gouv.finances.cp.utils.xml.marshal.NoeudModifiable;
import fr.gouv.finances.cp.utils.xml.marshal.XmlAttributes;
import fr.gouv.finances.cp.utils.xml.marshal.XmlMarshallable;
import fr.gouv.finances.cp.utils.xml.marshal.XmlOutputter;
import javax.xml.namespace.QName;

public class ParametersModel implements NoeudModifiable {
    Logger logger = Logger.getLogger(ParametersModel.class);
    private NoeudModifiable _NMParent = null;
    
    public static final transient String TAG = "parameters";
    public static final transient QName QN = new QName(TAG);
    private Vector<ParameterModel> parameters;
    private HashMap<String,ParameterModel> hParameters;
    
    public ParametersModel(QName tagName) {
        super();
        parameters = new Vector<ParameterModel> ();
        hParameters = new HashMap<String,ParameterModel>();
    }
    
    public Vector<ParameterModel> getParameters() {
        return parameters;
    }
    public ParameterModel getParameter(String paramName) {
        return hParameters.get(paramName);
    }
    
    public void addCharacterData(String cData) throws SAXException { }
    
    public void addChild(XmlMarshallable child, QName tagName) throws SAXException {
        if (ParameterModel.QN.equals(tagName)) {
            ParameterModel pm = (ParameterModel)child;
            pm.setParentAsNoeudModifiable(this);
            if(hParameters.containsKey(pm.getName())) {
                ParameterModel old = hParameters.get(pm.getName());
                parameters.remove(old);
                hParameters.remove(old.getName());
            }
            parameters.add(pm);
            hParameters.put(pm.getName(), pm);
        }
    }
    
    public XmlMarshallable getAttributes(XmlAttributes attributes) throws SAXException {
        return this;
    }
    
    public void marshall(XmlOutputter output) {
        output.startTag(TAG);
        for (ParameterModel pm:parameters) {
            pm.marshall(output);
        }
        output.endTag(TAG);
    }
    
    public void validate() throws InvalidXmlDefinition {
        for(ParameterModel p:parameters) p.validate();
    }
    
    @Override
    public ParametersModel clone()  {
        ParametersModel pm = new ParametersModel(QN);
        for (ParameterModel p:this.parameters) {
            try {pm.addChild(p.clone(), ParameterModel.QN);} catch (Throwable t) {}
        }
        return pm;
    }
    
    public void modifyAttr(String attrName, String value) { }
    
    public void modifyAttrs(Attributes attrs) {
        try {
            getAttributes(new XmlAttributes(attrs));
        } catch (Exception e) {
            logger.error("Erreur lors de la mise à jour des attributs : "+e);
        }
    }
    
    public void setParentAsNoeudModifiable(NoeudModifiable p) {
        this._NMParent = p;
    }
    public NoeudModifiable getParentAsNoeudModifiable() {
        return this._NMParent;
    }
    public NoeudModifiable getChildAsNoeudModifiable(String tagName, String id) {
        if (tagName.equals(ParameterModel.TAG)) {
            return hParameters.get(id);
        } else {
            return null;
        }
    }
    
    public String[] getChildIdAttrName(String childTagName) {
        if (ParameterModel.TAG.equals(childTagName)) {
            return new String[]{"name"};
        } else {
            return null;
        }
    }
    public String getIdValue() { return null; }
    
    public void resetCharData() { }
    private String configXPath = null;
    public String getConfigXPath() {
        if(configXPath==null) {
            if(getParentAsNoeudModifiable()!=null) configXPath = getParentAsNoeudModifiable().getConfigXPath();
            else configXPath="";
            configXPath+="/"+TAG;
        }
        return configXPath;
    }

    public XmlMarshallable getChildToModify(String uri, String localName, String qName, Attributes atts) {
        //return hParameters.get(atts.getValue("name"));
        return null;
    }

    public QName getQName() {
        return QN;
    }
}
